unit AffArbre;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus,ArbreDate, MyNewgrid,ColorStringGrid,Donnees,
  StructureDonnees,Gr32,GR32_Layers,GR32_Image;

type
  TFormAffArbre = class(TForm)
    PanelArbre: TPanel;
    ScrollBoxArbre: TScrollBox;
    PanelActivArbre: TPanel;
    PanelInfo: TPanel;
    BChoix: TPanel;
    PanelLongueurs: TPanel;
    MenuchoixArbre: TPopupMenu;
    AfficherTaxons: TMenuItem;
    AfficherBoitesArbre: TMenuItem;
    AfficherGroupes: TMenuItem;
    N1: TMenuItem;
    AfficherLongueurArbre: TMenuItem;
    Label3: TLabel;
    LongTot: TEdit;
    LPartielle: TLabel;
    LongPart: TEdit;
    Label1: TLabel;
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    Fermer: TMenuItem;
    Copier: TMenuItem;
    Imprimer: TMenuItem;
    N2: TMenuItem;
    EditerArbre: TMenuItem;
    ExplorerArbre: TMenuItem;
    InterditRevert: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure BChoixClick(Sender: TObject);
    procedure AfficherTaxonsClick(Sender: TObject);
    procedure AfficherBoitesArbreClick(Sender: TObject);
    procedure AfficherGroupesClick(Sender: TObject);
    procedure AfficherLongueurArbreClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PanelArbreResize(Sender: TObject);
    procedure CopierClick(Sender: TObject);
    procedure ImprimerClick(Sender: TObject);
    procedure FermerClick(Sender: TObject);
    procedure EditerArbreClick(Sender: TObject);
    procedure ExplorerArbreClick(Sender: TObject);
    procedure InterditRevertClick(Sender: TObject);
  private
    { Dclarations prives }
    InactiveMouseUp:Boolean;

    procedure AjusterInfo(Sender: TObject);
    procedure AncetreClique(sender:Tobject);
    procedure UngroupeEstNomme(Sender:Tobject);
    procedure UnGroupeEstANommer(Sender:Tobject);
    procedure Verifierarbre;
    procedure ArbreCladeMouseUp(Sender: TObject;Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure FermerFicheCarAncetre;
    procedure VerifierNoeuds(Sender:TObject);
  public
    { Dclarations publiques }
    AfDExcl,AfD,AfA:TAffichCoul;
    //AfOK,AfImpos,AfErr,AfMoins:TAffichCoul;
    LeDernierAncetreClique:TBranche;
    CaracCouleur:string;
    ArbreClade:TArbreDate;
    DemandeCopie:TNotifyEvent;
    DemandeImpression:TNotifyEvent;
    AjusterMatrice:TNotifyEvent;
    TabGrid1: TTabGrid;
    EstEditable:Boolean;
    MethodeParci:integer;
    procedure AjusteLongueurs;
    procedure InitialiseLongueur;
    procedure InitialiseEdition(Editable:Boolean);

    //procedure initialise(ChaineStruct:string);
  end;

var
  FormAffArbre: TFormAffArbre;

implementation

uses FenCaractAncetre;

{$R *.dfm}

procedure TFormAffArbre.FormCreate(Sender: TObject);
begin
  ArbreClade:=TArbreDate.Create(ScrollBoxArbre);
  ArbreClade.parent:=ScrollBoxArbre;
  ArbreClade.Align:=alNone;
  ArbreClade.Left:=0;
  ArbreClade.Top:=0;
  ArbreClade.TypeDArbre:=1;
  ArbreClade.EstModifiable:=False;
  ArbreClade.UneBrancheEstCliquee:=AncetreClique;
  ArbreClade.UnGroupeEstANommer:=UnGroupeEstANommer;
  ArbreClade.AjusterInfo:=AjusterInfo;
  ArbreClade.OnMouseUp:=ArbreCladeMouseUp;
  //ArbreClade.OnMouseDown:=ArbreCladeMouseDown;
  ArbreClade.LargeurDisponible:=PanelArbre.ClientWidth-12;//
  ArbreClade.HauteurDisponible:=PanelArbre.ClientHeight-PanelActivArbre.Height-12;//
  EstEditable:=False;
  MethodeParci:=0;
end;
procedure TFormAffArbre.InitialiseEdition(Editable:Boolean);
begin
  EstEditable:=Editable;
  ArbreClade.EstModifiable:=Editable;
  N2.Visible:=Editable;
  EditerArbre.Visible:=Editable;
  ExplorerArbre.Visible:=Editable;
  ExplorerArbre.Checked:=True;
  if EstEditable then
     ArbreClade.ArbreModifie:=VerifierNoeuds
  else
    ArbreClade.ArbreModifie:=Nil;

end;
procedure TFormAffArbre.VerifierNoeuds(Sender:TObject);
Var
  i,l:integer;
  LongCar:integer;
begin
  ArbreClade.LaSousCollection:=LaSousCollection;
  ArbreClade.CouleurAncetre:=clYellow32;
  ArbreClade.CouleurErreur:=clWhite32;
  ArbreClade.ListeCaracteres.Clear;
  CaracCouleur:='';
  for i:=TabGrid1.FixedCols to TabGrid1.ColCount-1 do
    begin
      if TabGrid1.SelectCol[i] then CaracCouleur:=TabGrid1.Cells[i,0];
      ArbreClade.ListeCaracteres.Add(TabGrid1.Cells[i,0]);
    end;
  ArbreClade.ConstruitPortraits(MethodeParci);//0:m. de Wagner (rversions et convergences acceptes)
  if CaracCouleur<>'' then
    ArbreClade.ColoreSuivantEtats(CaracCouleur,CouleursEtatsDef);
  l:=ArbreClade.CalculeLongueurTot(CaracCouleur,LongCar);
  Longtot.Text:=IntToStr(l);
  LongPart.Text:=IntToStr(LongCar);
end;
procedure TFormAffArbre.BChoixClick(Sender: TObject);
begin
  MenuChoixArbre.Popup(Left+BChoix.Width,Top+PanelActivArbre.Top);
end;
procedure TFormAffArbre.AjusterInfo(sender:Tobject);
begin
  PanelInfo.Caption:=Arbreclade.TexteInfo;
end;

procedure TFormAffArbre.AfficherTaxonsClick(Sender: TObject);
begin
  if (Not AfficherBoitesArbre.Checked) or (Not AfficherGroupes.Checked) then
    begin
      AfficherTaxons.Checked:=True;
      AfficherGroupes.Checked:=False;
    end
  else
    begin
      if Not AfficherTaxons.Checked then
        begin
          AfficherTaxons.Checked:=True;
          ArbreClade.BoitesSansTaxons:=False;
          ArbreClade.Redessine;
        end
      else
        begin
          AfficherTaxons.Checked:=False;
          ArbreClade.BoitesSansTaxons:=True;
          ArbreClade.Redessine;
        end;
    end;
end;

procedure TFormAffArbre.AfficherBoitesArbreClick(Sender: TObject);
begin
  if AfficherBoitesArbre.Checked then
    begin
      ArbreClade.DessinerBoites:=False;
      AfficherBoitesArbre.Checked:=False;
      ArbreClade.BoitesSansTaxons:=False;
      AfficherGroupes.Checked:=False;
      AfficherGroupes.Enabled:=False;
      AfficherTaxons.Checked:=True;
      AfficherTaxons.Enabled:=False;
      ArbreClade.Redessine;
    end
  else
    begin
      If AfficherGroupes.Checked then
        AfficherTaxons.Enabled:=True;
      AfficherGroupes.Enabled:=LaSousCollection.GroupesDeclares;//True;
      ArbreClade.DessinerBoites:=True;
      ArbreClade.ColoreBoitesParDefaut;
      ArbreClade.Redessine;
      AfficherBoitesArbre.Checked:=True;
    end;
end;

procedure TFormAffArbre.AfficherGroupesClick(Sender: TObject);
begin
  if AfficherGroupes.Checked then
    begin
      ArbreClade.BoitesSansTaxons:=False;
      Arbreclade.AfficherNomsGroupes:=False;
      ArbreClade.Redessine;
      AfficherGroupes.Checked:=False;
      AfficherTaxons.Checked:=True;
      AfficherTaxons.Enabled:=False;
    end
  else
    begin
      Arbreclade.AfficherNomsGroupes:=True;
      if AfficherBoitesArbre.Checked then
        AfficherTaxons.Enabled:=True;
      if Not AfficherTaxons.Checked then
        ArbreClade.BoitesSansTaxons:=True;
      ArbreClade.Redessine;
      AfficherGroupes.Checked:=True;
    end;
end;

procedure TFormAffArbre.AfficherLongueurArbreClick(Sender: TObject);
begin
  AfficherLongueurArbre.Checked:=Not AfficherLongueurArbre.Checked;
  PanelLongueurs.Visible:=AfficherLongueurArbre.Checked;
  AjusteLongueurs;
  PanelArbreResize(Nil);
end;
procedure TFormAffArbre.InitialiseLongueur;
Var
  l,LongCar:integer;
begin
  l:=ArbreClade.CalculeLongueurTot(CaracCouleur,LongCar);
  Longtot.Text:=IntToStr(l);
  if CaracCouleur<>'' then
    begin
      LPartielle.Visible:=True;
      LongPart.Visible:=True;
      LongPart.Text:=IntToStr(LongCar);
    end
  else
    begin
      LongPart.Visible:=False;
      LPartielle.Visible:=False;
    end;
end;
procedure TFormAffArbre.AjusteLongueurs;
Var
  LongCar:integer;//l,
begin
  if AfficherLongueurArbre.Checked then
    begin
      //l:=ArbreClade.CalculeLongueurTot(CaracCouleur,LongCar);
      //Longtot.Text:=IntToStr(l);
      if CaracCouleur<>'' then
        begin
          LongCar:=ArbreClade.CalculeLongueurCar(CaracCouleur);
          LPartielle.Visible:=True;
          LongPart.Visible:=True;
          LongPart.Text:=IntToStr(LongCar);
        end
      else
        begin
          LongPart.Visible:=False;
          LPartielle.Visible:=False;
        end;
    end;
end;
procedure TFormAffArbre.FormDestroy(Sender: TObject);
begin
  ArbreClade.Free;
end;

procedure TFormAffArbre.PanelArbreResize(Sender: TObject);
Var
 h:integer;
begin
  if ArbreClade<>Nil then
    if Length(ArbreClade.Branches)>1 then
      begin
        ScrollBoxArbre.Width:=PanelArbre.ClientWidth;
        h:=PanelArbre.ClientHeight-PanelActivArbre.Height;
        if PanelLongueurs.Visible then
          h:=h-PanelLongueurs.Height;
        ScrollBoxArbre.Height:=h;
        ArbreClade.LargeurDisponible:=PanelArbre.ClientWidth-12;//
        ArbreClade.HauteurDisponible:=h-12;//
        ArbreClade.Redessine;
      end;
end;

procedure TFormAffArbre.CopierClick(Sender: TObject);
begin
  if Assigned(DemandeCopie) then DemandeCopie(Self);
end;

procedure TFormAffArbre.ImprimerClick(Sender: TObject);
begin
  if Assigned(DemandeImpression) then DemandeImpression(Self);
end;

procedure TFormAffArbre.FermerClick(Sender: TObject);
begin
  Close;
  if Assigned(AjusterMatrice) then AjusterMatrice(Self);
end;
procedure TFormAffArbre.AncetreClique(sender:Tobject);
Var
  LeNoeud:TBranche;
  //LalisteDerivExcl:TStringList;
  //LalisteEtDerivExcl:TStringList;
  NomCar,NomEtat,nomTaxon:string;
  i,ValAge,lig:integer;
  ListeTaxons:TStringList; //Liste des taxons qui descendent de l'anctre sur lequel on a cliqu
  NomGroupe:string;
  ListeGroupes:TStringList;
  //chaine:string;
  ToutPrimitif:Boolean;
begin
  if ArbreClade.BrancheCliquee.estUnTaxon then
    begin
      if ArbreClade.BrancheCliquee.EstUnGroupeMonoPhyl and (ArbreClade.BrancheCliquee.NomGroupe='') then
        begin
          NomTaxon:=ArbreClade.BrancheCliquee.Nom;
          ListeTaxons:=TStringList.Create;
          ListeTaxons.Add(NomTaxon);
          LeNoeud:=ArbreClade.BrancheCliquee;
        end
      else
        exit;
    end
  else
    begin
      NomTaxon:='';
      LeNoeud:=ArbreClade.BrancheCliquee;
      ListeTaxons:=TStringList.Create;
      ListeTaxons.CommaText:=LeNoeud.TaxonsDescendants;

      if ListeTaxons.Count=0 then
        begin
          ListeTaxons.Free;
          exit;
        end;
    end;
  ListeGroupes:=TStringList.Create;
  FicheCarAncetre.Caption:='Caractres ('+Caption+')';
  if LeNoeud.NomGroupe<>'' then
    FicheCarAncetre.PanelNomAnc.Caption:='Anctre des '+LeNoeud.NomGroupe
  else
    FicheCarAncetre.PanelNomAnc.Caption:=LeNoeud.Nom;

  FicheCarAncetre.LTaxons.RowCount:= ListeTaxons.Count;
  For i:=0 to ListeTaxons.Count-1 do
    begin
      FicheCarAncetre.LTaxons.Cells[0,i]:=ListeTaxons[i];
    end;

  FicheCarAncetre.ColorStringGrid.RowCount:=TabGrid1.ColCount-TabGrid1.FixedCols+1;
  if LaSousCollection.AvecFossiles then
    FicheCarAncetre.ColorStringGrid.ColCount:=3
  else
    FicheCarAncetre.ColorStringGrid.ColCount:=2;
  FicheCarAncetre.ColorStringGrid.FixedCols:=1;
  FicheCarAncetre.ColorStringGrid.FixedRows:=1;
  ToutPrimitif:=True;
  //LalisteDerivExcl:=TStringList.Create;
  //LalisteEtDerivExcl:=TStringList.Create;

  //ArbreClade.RazCouleurBranches;
  ArbreClade.RazCouleurs;

  //ArbreClade.ConstruitPortraits(0);  //devrait tre inutile
  For i:=TabGrid1.FixedCols to TabGrid1.ColCount-1 do
    begin
      NomCar:=TabGrid1.Cells[i,0];
      NomEtat:=LeNoeud.Portrait.Etat(NomCar);
      lig:=i-TabGrid1.FixedCols+1;
      FicheCarAncetre.ColorStringGrid.Cells[0,lig]:=NomCar;
      FicheCarAncetre.ColorStringGrid.Cells[1,lig]:=NomEtat;
      Case LeNoeud.Portrait.Statut(NomCar) of
        0,1:FicheCarAncetre.ColorStringGrid.AffichCell[1,lig]:=AfA;
        2:begin
            FicheCarAncetre.ColorStringGrid.AffichCell[1,lig]:=AfD;
            ToutPrimitif:=False;
          end;
        3:begin
            FicheCarAncetre.ColorStringGrid.AffichCell[1,lig]:=AfDExcl;
            //LalisteDerivExcl.Add(NomCar);
            //LalisteEtDerivExcl.Add(NomEtat);
            NomGroupe:=LaSousCollection.NomGroupe(NomCar,NomEtat);
            if NomGroupe<>'' then
              ListeGroupes.Add(NomGroupe);
          end;
      end;
      if LaSousCollection.AvecFossiles then
        FicheCarAncetre.ColorStringGrid.Cells[2,lig]:=LaSousCollection.TrouveAge(NomCar,NomEtat,ValAge);
    end;
  FicheCarAncetre.Groupe.Clear;
  FicheCarAncetre.NumeroGroupe:=-1;
  FicheCarAncetre.PanAvertis.Visible:=false;
  FicheCarAncetre.PanCoulDExcl.AffichCell[0,0]:=AfDExcl;
  FicheCarAncetre.ModeTrouveGroupe:=False;
  if LeNoeud.NomGroupe<>'' then
    begin
      FicheCarAncetre.Groupe.Add(LeNoeud.NomGroupe);
      FicheCarAncetre.NumeroGroupe:=0;
    end
  else
    begin
      if ListeGroupes.Count>0 then
        begin
          FicheCarAncetre.Groupe.AddStrings(ListeGroupes);
          FicheCarAncetre.ModeTrouveGroupe:=True;
        end;
    end;
  ListeGroupes.Free;

  FicheCarAncetre.VerifieTableau;
  FicheCarAncetre.AjusteLegende;

  FicheCarAncetre.cD:=AfD.CouleurFond;
  FicheCarAncetre.cDE:=AfDExcl.CouleurFond;
  FicheCarAncetre.Classer;
  FicheCarAncetre.Show;
  FicheCarAncetre.FenetreAppel:=Self;

  if (nomcar<>'')  then
    begin
      LeDernierAncetreClique:=LeNoeud;
      if FicheCarAncetre.ModeTrouveGroupe then
        FicheCarAncetre.GroupeNomme:=UngroupeEstNomme;
    end;

  InactiveMouseUp:=True;
  //ArbreClade.RazCouleurs;
  {if AfficherBoitesArbre.Checked then
    ArbreClade.ColoreBoitesParDefaut; }

  LeNoeud.CouleurSurBoite:=Color32(CouleurBranchesGroupe);
  if LeNoeud.EstUnGroupeMonoPhyl then LeNoeud.FixeCouleurBranchesDescendants(Color32(CouleurBranchesGroupe),False)
  else if ToutPrimitif then LeNoeud.FixeCouleurBranchesDescendants(Color32(CouleurPrimitif),False)
  else LeNoeud.FixeCouleurBranchesDescendants(Color32(CouleurBranchesGroupe),True);
  LeNoeud.FixeCouleurAncetresDescendants(Color32(CouleurNoeudsGroupe));   //noeuds
  LeNoeud.CouleurAncetre:=Color32(CouleurAncetreClique);
  //VerifierArbre;//recherche des fossiles et des extragroupes  inutile si cela a t fait au dbut
  ArbreClade.Redessine;
  if Assigned(AjusterMatrice) then AjusterMatrice(Self);
  ListeTaxons.Free;
end;
procedure TFormAffArbre.UngroupeEstNomme;
begin
  if (LeDernierAncetreClique<>Nil) then
    begin
      LeDernierAncetreClique.NomGroupe:=FicheCarAncetre.Groupe[FicheCarAncetre.NumeroGroupe];
      FicheCarAncetre.GroupeNomme:=Nil;
      if ArbreClade.DessinerBoites then
        ArbreClade.Redessine;
    end;
end;
procedure TFormAffArbre.Verifierarbre;
Var
  i:integer;
  Tax:TTaxon;
begin
  ArbreClade.RazFossiles;
  ArbreClade.RAZExternes;
  For i:=0 to LaSousCollection.Taxons.NbTaxons-1 do
    begin
      Tax:=TTaxon(LaSousCollection.Taxons[i]);
      if LaSousCollection.EstFossile(i) then
        ArbreClade.MarqueCommeFossile(Tax.Nom);
      if LaSousCollection.EstExterne(i) then
        ArbreClade.MarqueCommeExterne(Tax.Nom);
    end;
end;

procedure TFormAffArbre.ArbreCladeMouseUp(Sender: TObject;Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  if FicheCarAncetre.FenetreAppel=Self then
    FermerFicheCarAncetre;
end;
procedure TFormAffArbre.FermerFicheCarAncetre;
begin
  If (not InactiveMouseUp) then
    begin
      ArbreClade.RazCouleurs;
      //VerifierNoeuds(Nil);
      VerifierArbre;
      if AfficherBoitesArbre.Checked then
        ArbreClade.ColoreBoitesParDefaut;
      ArbreClade.Redessine;
      FicheCarAncetre.Close;
      LeDernierAncetreClique:=Nil;
      FicheCarAncetre.GroupeNomme:=Nil;
      if Assigned(AjusterMatrice) then AjusterMatrice(Self);
      //VerifierNoeuds(self);
    end;
  InactiveMouseUp:=False;
end;
procedure TFormAffArbre.UnGroupeEstANommer(Sender:Tobject);
Var
  LeNoeud:TBranche;
  NomCar,NomEtat,nomTaxon:string;
  i,ValAge,lig:integer;
  ListeTaxons:TStringList; //Liste des taxons qui descendent de l'anctre sur lequel on a cliqu
  NomGroupe:string;
  ListeGroupes:TStringList;
  //chaine:string;
  ToutPrimitif:Boolean;
begin
  if ArbreClade.BrancheCliquee.estUnTaxon then
    begin
      if ArbreClade.BrancheCliquee.EstUnGroupeMonoPhyl and (ArbreClade.BrancheCliquee.NomGroupe='') then
        begin
          NomTaxon:=ArbreClade.BrancheCliquee.Nom;
          ListeTaxons:=TStringList.Create;
          ListeTaxons.Add(NomTaxon);
          LeNoeud:=ArbreClade.BrancheCliquee;
        end
      else
        exit;
    end
  else
    begin
      NomTaxon:='';
      LeNoeud:=ArbreClade.BrancheCliquee;
      //AjusteActive;
      ListeTaxons:=TStringList.Create;
      ListeTaxons.CommaText:=LeNoeud.TaxonsDescendants;

      if ListeTaxons.Count=0 then
        begin
          ListeTaxons.Free;
          exit;
        end;
    end;
  ListeGroupes:=TStringList.Create;
  FicheCarAncetre.Caption:='Caractres';
  FicheCarAncetre.PanelNomAnc.Caption:=LeNoeud.Nom;

  FicheCarAncetre.LTaxons.RowCount:= ListeTaxons.Count;
  For i:=0 to ListeTaxons.Count-1 do
    begin
      FicheCarAncetre.LTaxons.Cells[0,i]:=ListeTaxons[i];
    end;

  FicheCarAncetre.ColorStringGrid.RowCount:=TabGrid1.ColCount-TabGrid1.FixedCols+1;
  if LaSousCollection.AvecFossiles then
    FicheCarAncetre.ColorStringGrid.ColCount:=3
  else
    FicheCarAncetre.ColorStringGrid.ColCount:=2;
  FicheCarAncetre.ColorStringGrid.FixedCols:=1;
  FicheCarAncetre.ColorStringGrid.FixedRows:=1;
  ToutPrimitif:=True;
  //LalisteDerivExcl:=TStringList.Create;
  //LalisteEtDerivExcl:=TStringList.Create;
  For i:=TabGrid1.FixedCols to TabGrid1.ColCount-1 do
    begin
      NomCar:=TabGrid1.Cells[i,0];
      NomEtat:=LeNoeud.Portrait.Etat(NomCar);
      lig:=i-TabGrid1.FixedCols+1;
      FicheCarAncetre.ColorStringGrid.Cells[0,lig]:=NomCar;
      FicheCarAncetre.ColorStringGrid.Cells[1,lig]:=NomEtat;
      Case LeNoeud.Portrait.Statut(NomCar) of
        0,1:FicheCarAncetre.ColorStringGrid.AffichCell[1,lig]:=AfA;
        2:begin
            FicheCarAncetre.ColorStringGrid.AffichCell[1,lig]:=AfD;
            ToutPrimitif:=False;
          end;
        3:begin
            FicheCarAncetre.ColorStringGrid.AffichCell[1,lig]:=AfDExcl;
            //LalisteDerivExcl.Add(NomCar);
            //LalisteEtDerivExcl.Add(NomEtat);
            NomGroupe:=LaSousCollection.NomGroupe(NomCar,NomEtat);
            if NomGroupe<>'' then
              ListeGroupes.Add(NomGroupe);
          end;
      end;
      if LaSousCollection.AvecFossiles then
        FicheCarAncetre.ColorStringGrid.Cells[2,lig]:=LaSousCollection.TrouveAge(NomCar,NomEtat,ValAge);
    end;
  FicheCarAncetre.Groupe.Clear;
  FicheCarAncetre.NumeroGroupe:=-1;
  FicheCarAncetre.PanAvertis.Visible:=false;
  FicheCarAncetre.PanCoulDExcl.AffichCell[0,0]:=AfDExcl;
  FicheCarAncetre.ModeTrouveGroupe:=False;
  if LeNoeud.NomGroupe<>'' then
    begin
      FicheCarAncetre.Groupe.Add(LeNoeud.NomGroupe);
      FicheCarAncetre.NumeroGroupe:=0;
    end
  else
    begin
      if ListeGroupes.Count>0 then
        begin
          FicheCarAncetre.Groupe.AddStrings(ListeGroupes);
          FicheCarAncetre.ModeTrouveGroupe:=True;
        end;
    end;
  ListeGroupes.Free;

  FicheCarAncetre.VerifieTableau;
  FicheCarAncetre.AjusteLegende;

  FicheCarAncetre.cD:=AfD.CouleurFond;
  FicheCarAncetre.cDE:=AfDExcl.CouleurFond;
  FicheCarAncetre.Classer;
  FicheCarAncetre.FenetreAppel:=Self;
  FicheCarAncetre.Show;
  if (nomcar<>'')  then
    begin
      LeDernierAncetreClique:=LeNoeud;
      if FicheCarAncetre.ModeTrouveGroupe then
        FicheCarAncetre.GroupeNomme:=UngroupeEstNomme;
    end;

  InactiveMouseUp:=True;
  ArbreClade.RazCouleurs;
  if AfficherBoitesArbre.Checked then
    ArbreClade.ColoreBoitesParDefaut;

  LeNoeud.CouleurSurBoite:=Color32(CouleurBranchesGroupe);
  if LeNoeud.EstUnGroupeMonoPhyl then LeNoeud.FixeCouleurBranchesDescendants(Color32(CouleurBranchesGroupe),False)
  else if ToutPrimitif then LeNoeud.FixeCouleurBranchesDescendants(Color32(CouleurPrimitif),False)
  else LeNoeud.FixeCouleurBranchesDescendants(Color32(CouleurBranchesGroupe),True);
  LeNoeud.FixeCouleurAncetresDescendants(Color32(CouleurNoeudsGroupe));   //noeuds
  LeNoeud.CouleurAncetre:=Color32(CouleurAncetreClique);
  VerifierArbre;
  ArbreClade.Redessine;
  ListeTaxons.Free;
  if Assigned(AjusterMatrice) then AjusterMatrice(Self);
end;

procedure TFormAffArbre.EditerArbreClick(Sender: TObject);
begin
  FermerFicheCarAncetre;
  ArbreClade.EstModifiable:=True;
  EditerArbre.Checked:=True;
end;

procedure TFormAffArbre.ExplorerArbreClick(Sender: TObject);
begin
  FermerFicheCarAncetre;
  ArbreClade.EstModifiable:=False;
  ExplorerArbre.Checked:=True;
end;

procedure TFormAffArbre.InterditRevertClick(Sender: TObject);
begin
  InterditRevert.Checked:=Not InterditRevert.Checked;
  if InterditRevert.Checked then
    MethodeParci:=1
  else
    MethodeParci:=0;
  ArbreClade.ConstruitPortraits(MethodeParci);
  FermerFicheCarAncetre;
  if CaracCouleur<>'' then
    begin
      ArbreClade.RAZCouleurs;
      ArbreClade.ColoreSuivantEtats(CaracCouleur,CouleursEtatsDef);
      ArbreClade.Redessine;
    end;
end;

end.
